/* Dottest.cc

   A program set up to perform the
   Dot-product test on operator fopMMOstk, which performs MMO and stack.

   The program writes to standard output the fractional error 
   between the two sides of the Dot product test.
   */

#include <Axis.h>
#include <Axislist.h>
#include <iostream.h>
#include <fopdotprod.h>

#include <fopkmostk.h>

int main() {

/**********************************/
    float vel=1.5;

    cout << "\nDot product test, kmo-stack operator \n";
    cout << "vel="<<vel<<"\n";

	// The Axes to operate on
    Axis m(0.0,0.025,20,"m");
    Axis x(0.0,0.025,20,"x");
    Axis t(0.0,0.004,200,"t");

	// Set up the input Axislist
    Axislist inlist(2);
    inlist.list[0] = t; inlist.list[1] = m;

	// Set up the output Axislist
    Axislist outlist(2);
    outlist.list[0] = t; outlist.list[1] = x;

	// Construct the operator
    fopKMOstk op(t,m,x,2.0/vel);

/***********************************/

	// Call Dot-product test routine
	// and output result
    cout << "\n Relative error : " << fopdotprod(inlist,outlist,op) << "\n";

    return(0);
}
