#include <fopkmostk.h>
#include <fopkmostksingle.h>
#include <foparray.h>
#include <fopmerge.h>
#include <fopadjoint.h>
#include <fopstack.h>

// Operator to do KMO and stack (as adjoint).

fopKMOstk::fopKMOstk(Axis & t,Axis & m, Axis & x, float s) {

   // make an array of kmostack operators
   fopArray * kmostkops = new fopArray( 1, m.length );

   for ( int i=0; i<m.length; i++ ){ 
       fopKMOstksingle * kmostack = new fopKMOstksingle( t, x, m.value(i), s );
       kmostkops->set( 0, i, kmostack );
   }
   fopMerge   * mergeop   = new fopMerge( m );
   fopAdjoint * makepanel = new fopAdjoint( mergeop );

   num = 2;
   ops = new foperator*[num]; 
   ops[0] = kmostkops;
   ops[1] = makepanel;
}

fopKMOstk::fopKMOstk(Axis & t,Axis & x, Axis & m ,float s[]) {

   // make an array of kmostack operators
   fopArray * kmostkops = new fopArray( 1, m.length );

   for ( int i=0; i<m.length; i++ ){ 
       fopKMOstksingle * kmostack = new fopKMOstksingle( t, x, m.value(i), s );
       kmostkops->set( 0, i, kmostack );
   }
   fopMerge   * mergeop   = new fopMerge( m );
   fopAdjoint * makepanel = new fopAdjoint( mergeop );

   num = 2;
   ops = new foperator*[num]; 
   ops[0] = kmostkops;
   ops[1] = makepanel;
}
