#include <fopnmostk.h>

#include <farray.h>
#include <math.h>

fopNMOstk::fopNMOstk(Axis & t,Axis & x,float s) {
    slow = new float[t.length];
    for (int i=0; i<t.length; i++) {
	slow[i] = s;
    }
    Axislist temp(2);
    temp.list[0] = t;
    temp.list[1] = x;
    inaxis = temp;
    outaxis = (Axislist) t;
}

fopNMOstk::fopNMOstk(Axis & t,Axis & x,float s[]) {
    slow = new float[t.length];
    for (int i=0; i<t.length; i++) {
	slow[i] = s[i];
    }
    Axislist temp(2);
    temp.list[0] = t;
    temp.list[1] = x;
    inaxis = temp;
    outaxis = (Axislist) t;
}

fopNMOstk::~fopNMOstk() {
    delete[] slow;
}

void fopNMOstk::apply(floatArray & in,floatArray & out,int adj,
		      Axislist & outaxes, Axislist & inaxes) {
    for (int i=0; i<inaxes[1].length; i++) {
	float x = inaxes[1].value(i);
	for (int j=0; j<inaxes[0].length; j++) {
	    float z = inaxes[0].value(j);
	    float xs = x * slow[j];
	    int it = inaxes[0].index(sqrt(z*z + xs*xs));
	    if (it < inaxes[0].length) {
		if (adj) {
		    in(it,i) += out(j);
		} else {
		    out(j) += in(it,i);
		}
	    }
	}
    }
}
