#include <fopvelan.h>

#include <fopnmostk.h>
#include <fopmerge.h>
#include <foparray.h>
#include <fopadjoint.h>
#include <Axis.h>

// Operator to do Velocity Analysis

fopVelan::fopVelan(Axis & t, Axis & x, Axis& s, int mode ) {

int len = s.length;

// make a ( 1, len ) array of nmostack operators
fopArray * nmostkops = new fopArray(  1, len );

for( int i=0; i<len; i++ ){
    float slow ;
    if( mode == 0 ){
       slow = s.value(i);
    }else{
       slow = 1./s.value(i);
    }
    // build a single nmostack operator
    fopNMOstk * stkop = new fopNMOstk(t, x, slow );
    // put it in the array
    nmostkops->set( 0, i, stkop );
}

 // make a Merge operator
fopMerge * mergeop = new fopMerge( s );

 // make its adjoint
fopAdjoint * adjmerge = new fopAdjoint( mergeop );

// make a chain of the two 
num=2;
ops = new foperator*[2];
ops[0] = nmostkops;
ops[1] = adjmerge;

}

